require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_64_TOPOLOGY_H)) {
    eval 'sub _ASM_X86_64_TOPOLOGY_H () {1;}' unless defined(&_ASM_X86_64_TOPOLOGY_H);
    require 'linux/config.ph';
    if(defined(&CONFIG_NUMA)) {
	require 'asm/mpspec.ph';
	require 'asm/bitops.ph';
	if(defined(&CONFIG_ACPI_NUMA)) {
	    eval 'sub node_distance {
	        my($a,$b) = @_;
    		eval q( &__node_distance($a,$b));
	    }' unless defined(&node_distance);
	}
	eval 'sub cpu_to_node {
	    my($cpu) = @_;
    	    eval q(( $cpu_to_node[$cpu]));
	}' unless defined(&cpu_to_node);
	eval 'sub parent_node {
	    my($node) = @_;
    	    eval q(($node));
	}' unless defined(&parent_node);
	eval 'sub node_to_first_cpu {
	    my($node) = @_;
    	    eval q(( &first_cpu( $node_to_cpumask[$node])));
	}' unless defined(&node_to_first_cpu);
	eval 'sub node_to_cpumask {
	    my($node) = @_;
    	    eval q(( $node_to_cpumask[$node]));
	}' unless defined(&node_to_cpumask);
	eval 'sub pcibus_to_node {
	    my($bus) = @_;
    	    eval q((( ($bus->{sysdata}))));
	}' unless defined(&pcibus_to_node);
	eval 'sub pcibus_to_cpumask {
	    my($bus) = @_;
    	    eval q( &node_to_cpumask( &pcibus_to_node($bus)););
	}' unless defined(&pcibus_to_cpumask);
	eval 'sub numa_node_id () {
	    eval q( &read_pda( &nodenumber));
	}' unless defined(&numa_node_id);
	eval 'sub SD_NODE_INIT () { { . &span =  &CPU_MASK_NONE, . &parent =  &NULL, . &groups =  &NULL, . &min_interval = 8, . &max_interval = 32, . &busy_factor = 32, . &imbalance_pct = 125, . &cache_nice_tries = 2, . &busy_idx = 3, . &idle_idx = 2, . &newidle_idx = 0, . &wake_idx = 1, . &forkexec_idx = 1, . &per_cpu_gain = 100, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_FORK |  &SD_BALANCE_EXEC |  &SD_WAKE_BALANCE, . &last_balance =  &jiffies, . &balance_interval = 1, . &nr_balance_failed = 0, };}' unless defined(&SD_NODE_INIT);
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub topology_physical_package_id {
	    my($cpu) = @_;
    	    eval q(( $phys_proc_id[$cpu] ==  &BAD_APICID ? -1:  $phys_proc_id[$cpu]));
	}' unless defined(&topology_physical_package_id);
	eval 'sub topology_core_id {
	    my($cpu) = @_;
    	    eval q(( $cpu_core_id[$cpu] ==  &BAD_APICID ? 0:  $cpu_core_id[$cpu]));
	}' unless defined(&topology_core_id);
	eval 'sub topology_core_siblings {
	    my($cpu) = @_;
    	    eval q(( $cpu_core_map[$cpu]));
	}' unless defined(&topology_core_siblings);
	eval 'sub topology_thread_siblings {
	    my($cpu) = @_;
    	    eval q(( $cpu_sibling_map[$cpu]));
	}' unless defined(&topology_thread_siblings);
    }
    require 'asm-generic/topology.ph';
}
1;
